searchNodes=[{"doc":"This module defines the macros needed to use Skogsra e.g: defmodule MyApp.Settings do use Skogsra @envdoc &quot;My hostname&quot; app_env :my_hostname, :myapp, :hostname, default: &quot;localhost&quot; end","ref":"Skogsra.html","title":"Skogsra","type":"module"},{"doc":"Imports app_env/3 and app_env/4. Additionally generates the function template( For now is just equivalent to use import Skogsra.","ref":"Skogsra.html#__using__/1","title":"Skogsra.__using__/1","type":"macro"},{"doc":"Creates a function to retrieve specific environment/application variables values. The function created is named function_name and will get the value associated with an application called app_name and one or several parameters keys. Optionally, receives a list of options. Available options: OptionTypeDefaultDescription defaultanynilSets the Default value for the variable. typeSkogsra.Env.type():binarySets the explicit type for the variable. os_envbinaryautogeneratedOverrides automatically generated OS environment variable name. binding_orderSkogra.Env.bindings()[:system, :config]Sets the load order for variable binding. binding_skipSkogra.Env.bindings()[]Which variable bindings should be skipped. requiredbooleanfalseWhether the variable is required or not. cachedbooleantrueWhether the variable should be cached or not. namespacemodulenilOverrides any namespace. e.g: For the following declaration: app_env :db_password, :myapp, [:mydb, :password], default: &quot;password&quot;, will generate: db_password/0 and db_password/1 for getting the variable&#39;s value without or with namespace respectively. It returns :ok and :error tuples. db_password!/0 and db_password!/1 for getting the variable&#39;s value without or with namespace respectively. It fails on error. reload_db_password/0 and reload_db_password/1 for reloading the variable&#39;s value in the cache without or with namespace respectively. put_db_password/1 and put_db_password/2 for settings a new value for the variable directly to the cache without or with namespace respectively. A call to db_password/0 will try to get a value: From the OS environment variable $MYAPP_MYDB_PASSWORD (can be overriden by the option os_env). From the configuration file e.g: config :myapp, mydb: [password: &quot;some password&quot;] From the default value if it exists (In this case, it would return &quot;password&quot;). A call to db_password/1 with namespace Test will try to get a value: From the OS environment variable $TEST_MYAPP_MYDB_PASSWORD. From the configuration file e.g: config :myapp, Test, mydb: [password: &quot;some test password&quot;] From the OS environment variable $MYAPP_MYDB_PASSWORDT. From the configuraton file e.g: config :myapp, mydb: [password: &quot;some password&quot;] From the default value if it exists. In our example, &quot;password&quot;.","ref":"Skogsra.html#app_env/4","title":"Skogsra.app_env/4","type":"macro"},{"doc":"This module defines the core API for Skogsra.","ref":"Skogsra.Core.html","title":"Skogsra.Core","type":"module"},{"doc":"Gets the value of a given env.","ref":"Skogsra.Core.html#get_env/1","title":"Skogsra.Core.get_env/1","type":"function"},{"doc":"Gets the value of a given env. Fails on error.","ref":"Skogsra.Core.html#get_env!/1","title":"Skogsra.Core.get_env!/1","type":"function"},{"doc":"Puts a new value for an env.","ref":"Skogsra.Core.html#put_env/2","title":"Skogsra.Core.put_env/2","type":"function"},{"doc":"Reloads an env variable.","ref":"Skogsra.Core.html#reload_env/1","title":"Skogsra.Core.reload_env/1","type":"function"},{"doc":"This module defines a Skogsra environment variable.","ref":"Skogsra.Env.html","title":"Skogsra.Env","type":"module"},{"doc":"Environment variable struct.","ref":"Skogsra.Env.html#__struct__/0","title":"Skogsra.Env.__struct__/0","type":"function"},{"doc":"Gets the binding order for a Skogsra environment variable.","ref":"Skogsra.Env.html#binding_order/1","title":"Skogsra.Env.binding_order/1","type":"function"},{"doc":"Whether the Skogsra environment variable is cached or not.","ref":"Skogsra.Env.html#cached?/1","title":"Skogsra.Env.cached?/1","type":"function"},{"doc":"Gets the default value for a Skogsra environment variable.","ref":"Skogsra.Env.html#default/1","title":"Skogsra.Env.default/1","type":"function"},{"doc":"Gets extra options.","ref":"Skogsra.Env.html#extra_options/1","title":"Skogsra.Env.extra_options/1","type":"function"},{"doc":"Creates a new Skogsra environment variable.","ref":"Skogsra.Env.html#new/4","title":"Skogsra.Env.new/4","type":"function"},{"doc":"Gets the OS variable name for the Skogsra environment variable.","ref":"Skogsra.Env.html#os_env/1","title":"Skogsra.Env.os_env/1","type":"function"},{"doc":"Whether the Skogsra environment variable is required or not.","ref":"Skogsra.Env.html#required?/1","title":"Skogsra.Env.required?/1","type":"function"},{"doc":"Gets the type of the Skogsra environment variable.","ref":"Skogsra.Env.html#type/1","title":"Skogsra.Env.type/1","type":"function"},{"doc":"Application name.","ref":"Skogsra.Env.html#t:app_name/0","title":"Skogsra.Env.app_name/0","type":"type"},{"doc":"Variable binding.","ref":"Skogsra.Env.html#t:binding/0","title":"Skogsra.Env.binding/0","type":"type"},{"doc":"Variable binding list.","ref":"Skogsra.Env.html#t:bindings/0","title":"Skogsra.Env.bindings/0","type":"type"},{"doc":"Key.","ref":"Skogsra.Env.html#t:key/0","title":"Skogsra.Env.key/0","type":"type"},{"doc":"List of keys that lead to the value of the variable.","ref":"Skogsra.Env.html#t:keys/0","title":"Skogsra.Env.keys/0","type":"type"},{"doc":"Variable namespace.","ref":"Skogsra.Env.html#t:namespace/0","title":"Skogsra.Env.namespace/0","type":"type"},{"doc":"Environment variable options. binding_order - Variable binding load order. binding_skip - Skips loading a variable from the list of bindings. os_env - The name of the OS environment variable. type - Type to cast the OS environment variable value. namespace - Default namespace for the variable. default - Default value. required - Whether the variable is required or not. cached - Whether the variable is cached or not.","ref":"Skogsra.Env.html#t:option/0","title":"Skogsra.Env.option/0","type":"type"},{"doc":"Environment variable options:","ref":"Skogsra.Env.html#t:options/0","title":"Skogsra.Env.options/0","type":"type"},{"doc":"Skogsra environment variable.","ref":"Skogsra.Env.html#t:t/0","title":"Skogsra.Env.t/0","type":"type"},{"doc":"Types.","ref":"Skogsra.Env.html#t:type/0","title":"Skogsra.Env.type/0","type":"type"},{"doc":"This module defines the helpers for the variable cache. The cache works with persistent terms.","ref":"Skogsra.Cache.html","title":"Skogsra.Cache","type":"module"},{"doc":"Gets a variable value env from the cache.","ref":"Skogsra.Cache.html#get_env/1","title":"Skogsra.Cache.get_env/1","type":"function"},{"doc":"Stores a variable env in a persistent term.","ref":"Skogsra.Cache.html#put_env/2","title":"Skogsra.Cache.put_env/2","type":"function"},{"doc":"This module defines the functions and behaviours for casting Skogsra types.","ref":"Skogsra.Type.html","title":"Skogsra.Type","type":"behaviour"},{"doc":"Uses Skogsra.Type for implementing the behaviour e.g. a naive implementation for casting &quot;1, 2, 3, 4&quot; to [&quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;] would be: defmodule MyList do use Skogsra.Type def cast(value) when is_binary(value) do list = value |&gt; String.split(~r/,/) |&gt; Enum.map(&amp;String.trim/1) {:ok, list} end def cast(_) do :error end end","ref":"Skogsra.Type.html#__using__/1","title":"Skogsra.Type.__using__/1","type":"macro"},{"doc":"Callback for casting a value.","ref":"Skogsra.Type.html#c:cast/1","title":"Skogsra.Type.cast/1","type":"callback"},{"doc":"Casts an environment variable.","ref":"Skogsra.Type.html#cast/2","title":"Skogsra.Type.cast/2","type":"function"},{"doc":"This module defines the functions to get variables from the application configuration.","ref":"Skogsra.App.html","title":"Skogsra.App","type":"module"},{"doc":"Variable binding behaviour.","ref":"Skogsra.Binding.html","title":"Skogsra.Binding","type":"behaviour"},{"doc":"Uses the Skogsra.Binding behaviour.","ref":"Skogsra.Binding.html#__using__/1","title":"Skogsra.Binding.__using__/1","type":"macro"},{"doc":"","ref":"Skogsra.Binding.html#get_env/2","title":"Skogsra.Binding.get_env/2","type":"function"},{"doc":"Callback for getting an environment variable.","ref":"Skogsra.Binding.html#c:get_env/2","title":"Skogsra.Binding.get_env/2","type":"callback"},{"doc":"Callback for initializing binding.","ref":"Skogsra.Binding.html#c:init/1","title":"Skogsra.Binding.init/1","type":"callback"},{"doc":"This module defines the functions to get environment variables from the OS.","ref":"Skogsra.Sys.html","title":"Skogsra.Sys","type":"module"},{"doc":"This module defines the documentation generators.","ref":"Skogsra.Docs.html","title":"Skogsra.Docs","type":"module"},{"doc":"Generates docs for a variable given its module, function_name, app_name, keys to find it, options and custom docs.","ref":"Skogsra.Docs.html#gen_full_docs/6","title":"Skogsra.Docs.gen_full_docs/6","type":"function"},{"doc":"Generates put docs for a variable given its module and function_name.","ref":"Skogsra.Docs.html#gen_put_docs/3","title":"Skogsra.Docs.gen_put_docs/3","type":"function"},{"doc":"Generates reload docs for a variable given its module and function_name.","ref":"Skogsra.Docs.html#gen_reload_docs/3","title":"Skogsra.Docs.gen_reload_docs/3","type":"function"},{"doc":"Generates short docs for a variable given its module, function_name, and custom docs.","ref":"Skogsra.Docs.html#gen_short_docs/3","title":"Skogsra.Docs.gen_short_docs/3","type":"function"},{"doc":"Custom docs.","ref":"Skogsra.Docs.html#t:docs/0","title":"Skogsra.Docs.docs/0","type":"type"},{"doc":"Function name.","ref":"Skogsra.Docs.html#t:function_name/0","title":"Skogsra.Docs.function_name/0","type":"type"},{"doc":"This module defines the spec generators.","ref":"Skogsra.Spec.html","title":"Skogsra.Spec","type":"module"},{"doc":"Generates spec for a bang function.","ref":"Skogsra.Spec.html#gen_bang_spec/2","title":"Skogsra.Spec.gen_bang_spec/2","type":"function"},{"doc":"Generates spec for a configuration function.","ref":"Skogsra.Spec.html#gen_full_spec/2","title":"Skogsra.Spec.gen_full_spec/2","type":"function"},{"doc":"Generates put spec for a configuration function.","ref":"Skogsra.Spec.html#gen_put_spec/2","title":"Skogsra.Spec.gen_put_spec/2","type":"function"},{"doc":"Generates reload spec for a configuration function.","ref":"Skogsra.Spec.html#gen_reload_spec/2","title":"Skogsra.Spec.gen_reload_spec/2","type":"function"},{"doc":"This module defines several templates for OS environment variable definitions.","ref":"Skogsra.Template.html","title":"Skogsra.Template","type":"module"},{"doc":"Template internal structure.","ref":"Skogsra.Template.html#__struct__/0","title":"Skogsra.Template.__struct__/0","type":"function"},{"doc":"Generates a template.","ref":"Skogsra.Template.html#generate/2","title":"Skogsra.Template.generate/2","type":"function"},{"doc":"Builds a template struct from a map.","ref":"Skogsra.Template.html#new/1","title":"Skogsra.Template.new/1","type":"function"},{"doc":"A template struct.","ref":"Skogsra.Template.html#t:t/0","title":"Skogsra.Template.t/0","type":"type"},{"doc":"Template type.","ref":"Skogsra.Template.html#t:type/0","title":"Skogsra.Template.type/0","type":"type"},{"doc":"This module defines a JSON config provider for Skogsra. Important: You need to add {:jason, &quot;~&gt; 1.1&quot;} as a dependency along with Skogsra because the dependency is optional. The following is an example for Ecto configuration in a file called /etc/my_app/config.yml: [ { &quot;app&quot;: &quot;my_app&quot;, &quot;module&quot;: &quot;MyApp.Repo&quot;, &quot;config&quot;: { &quot;database&quot;: &quot;my_app_db&quot;, &quot;username&quot;: &quot;postgres&quot;, &quot;password&quot;: &quot;postgres&quot;, &quot;hostname&quot;: &quot;localhost&quot;, &quot;port&quot;: 5432 } } ] Then in your release configuration you can add the following: config_providers: [{Skogsra.Provider.Json, [&quot;/etc/my_app/config.json&quot;]}] Once the system boots, it&#39;ll parse and add the JSON configuration.","ref":"Skogsra.Provider.Json.html","title":"Skogsra.Provider.Json","type":"module"},{"doc":"This module defines a YAML config provider for Skogsra. Important: You need to add {:yamerl, &quot;~&gt; 0.7&quot;} as a dependency along with Skogsra because the dependency is optional. The following is an example for Ecto configuration: # file: /etc/my_app/config.yml - app: &quot;my_app&quot; module: &quot;MyApp.Repo&quot; config: database: &quot;my_app_db&quot; username: &quot;postgres&quot; password: &quot;postgres&quot; hostname: &quot;localhost&quot; port: 5432 Then in your release configuration you can add the following: config_providers: [{Skogsra.Provider.Yaml, [&quot;/etc/my_app/config.yml&quot;]}] Once the system boots, it&#39;ll parse and add the YAML configuration.","ref":"Skogsra.Provider.Yaml.html","title":"Skogsra.Provider.Yaml","type":"module"},{"doc":"","ref":"Skogsra.Provider.Yaml.html#t:key/0","title":"Skogsra.Provider.Yaml.key/0","type":"type"},{"doc":"Skogsrå The Skogsrå was a mythical creature of the forest that appears in the form of a small, beautiful woman with a seemingly friendly temperament. However, those who are enticed into following her into the forest are never seen again. This library attempts to improve the use of OS environment variables for application configuration: Variable defaults. Automatic type casting of values. Automatic docs and spec generation. OS environment template generation. Runtime reloading. Setting variable&#39;s values at runtime. Fast cached values access by using :persistent_term as temporal storage. Custom variable bindings. YAML and JSON configuration providers for Elixir releases.","ref":"readme.html","title":"Skogsrå","type":"extras"},{"doc":"You would create a config module e.g: defmodule MyApp.Config do use Skogsra @envdoc &quot;My hostname&quot; app_env :my_hostname, :myapp, :hostname, default: &quot;localhost&quot; end Calling MyApp.Config.my_hostname() will retrieve the value for the hostname in the following order: From the OS environment variable $MYAPP_HOSTNAME (can be overriden by the option os_env). From the configuration file e.g: config :myapp, hostname: &quot;my.custom.host&quot; From the default value if it exists (In this case, it would return &quot;localhost&quot;).","ref":"readme.html#small-example","title":"Skogsrå - Small example","type":"extras"},{"doc":"There are several options for configuring an environment variables: OptionTypeDefaultDescription defaultanynilSets the Default value for the variable. typeSkogsra.Env.type():binarySets the explicit type for the variable. os_envbinaryautogeneratedOverrides automatically generated OS environment variable name. binding_orderSkogra.Env.bindings()[:system, :config]Sets the load order for variable binding. binding_skipSkogra.Env.bindings()[]Which variable bindings should be skipped. requiredbooleanfalseWhether the variable is required or not. cachedbooleantrueWhether the variable should be cached or not. IMPORTANT: Options skip_system: true and skip_config: true have been deprecated in favour of binding_skip: [:system] and binding_skip: [:config] respectively. Additional topics: Automatic type casting. Explicit type casting. Explicit OS environment variable names. Required variables. Caching variables. Handling different environments. Setting and reloading variables. Automatic docs generation. Automatic spec generation. Automatic template generation. Custom variable bindins. Elixir release YAML and JSON config providers. Using with Hab. Installation.","ref":"readme.html#available-options","title":"Skogsrå - Available options","type":"extras"},{"doc":"If the default value is set (and no explicit type is found), the variable value will be casted as the same type of the default value. For this to work, the default value should be of the following types: :binary :integer :float. :boolean :atom e.g. in the following example, the value will be casted to :atom automatically: defmodule MyApp.Config do use Skogsra @envdoc &quot;My environment&quot; app_env :my_environment, :myapp, :environment, default: :prod end If either of the system OS or the application environment variables are defined, Skogsrå will try to cast their values to the default value&#39;s type which it atom e.g: iex(1)&gt; System.get_env(&quot;MYAPP_ENVIRONMENT&quot;) &quot;staging&quot; iex(2)&gt; MyApp.Config.my_environment() {:ok, :staging} or iex(1)&gt; Application.get_env(:myapp, :environment) &quot;staging&quot; iex(2)&gt; MyApp.Config.my_environment() {:ok, :staging} Note: If the variable is already of the desired type, it won&#39;t be casted.","ref":"readme.html#automatic-type-casting","title":"Skogsrå - Automatic type casting","type":"extras"},{"doc":"A type can be explicitly set. The available types are: :binary (default). :integer. :float. :boolean. :atom. :module (modules loaded in the system). :unsafe_module (modules that might or might not be loaded in the system) A module name with an implementation for the behaviour Skogsra.Type. e.g. a possible implementation for casting &quot;1, 2, 3, 4&quot; to [integer()] would be: defmodule MyList do use Skogsra.Type @impl Skogsra.Type def cast(value) def cast(value) when is_binary(value) do list = value |&gt; String.split(~r/,/) |&gt; Stream.map(&amp;String.trim/1) |&gt; Enum.map(&amp;String.to_integer/1) {:ok, list} end def cast(value) when is_list(value) do if Enum.all?(value, &amp;is_integer/1), do: {:ok, value}, else: :error end def cast(_) do :error end end If then we define the following enviroment variable with Skogsrå: defmodule MyApp.Config do use Skogsra app_env :my_integers, :myapp, :integers, type: MyList end If either of the system OS or the application environment variables are defined, Skogsrå will try to cast their values using our implementation e.g: iex(1)&gt; System.get_env(&quot;MYAPP_INTEGERS&quot;) &quot;1, 2, 3&quot; iex(2)&gt; MyApp.Config.my_integers() {:ok, [1, 2, 3]} or iex(1)&gt; Application.get_env(:myapp, :integers) [1, 2, 3] iex(2)&gt; MyApp.Config.my_integers() {:ok, [1, 2, 3]} Important: The default value is not cast according to type.","ref":"readme.html#explicit-type-casting","title":"Skogsrå - Explicit type casting","type":"extras"},{"doc":"Though Skogsrå automatically generates the names for the OS environment variables, they can be overriden by using the option os_env e.g: defmodule MyApp.Config do use Skogsra app_env :db_hostname, :myapp, [:postgres, :hostname], os_env: &quot;PGHOST&quot; end This will override the value $MYAPP_POSTGRES_HOSTNAME with $PGHOST e.g: iex(1)&gt; System.get_env(&quot;MYAPP_POSTGRES_HOSTNAME&quot;) &quot;unreachable&quot; iex(2)&gt; System.get_env(&quot;PGHOST&quot;) &quot;reachable&quot; iex(3)&gt; MyApp.Config.db_hostname() {:ok, &quot;reachable&quot;}","ref":"readme.html#explicit-os-environment-variable-names","title":"Skogsrå - Explicit OS environment variable names","type":"extras"},{"doc":"It is possible to set a environment variable as required with the required option e.g: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, required: true end If none of the system OS or the application environment variables are defined, Skogsrå will return an error e.g: iex(1)&gt; System.get_env(&quot;MYAPP_PORT&quot;) nil iex(2)&gt; Application.get_env(:myapp, :port) nil iex(2)&gt; MyApp.Config.my_port() {:error, &quot;Variable port in app myapp is undefined&quot;}","ref":"readme.html#required-variables","title":"Skogsrå - Required variables","type":"extras"},{"doc":"If it&#39;s necessary to keep several environments, it&#39;s possible to use a namespace e.g. given the following variable: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, default: 4000 end Calling MyApp.Config.my_port(Test) will retrieve the value for the hostname in the following order: From the OS environment variable $TEST_MYAPP_PORT. From the configuration file e.g: config :myapp, Test, port: 4001 From the OS environment variable $MYAPP_PORT. From the configuraton file e.g: config :myapp, port: 80 From the default value if it exists. In our example, 4000. The ability of loading different environments allows us to do the following with our configuration file: # file: config/config.exs use Mix.Config config :myapp, Prod port: 80 config :myapp, Test, port: 4001 config :myapp, port: 4000 While our Skogsrå module would look like: defmodule MyApp.Config do use Skogsra @envdoc &quot;Application environment&quot; app_env :env, :myapp, :environment, type: :unsafe_module @envdoc &quot;Application port&quot; app_env :port, :myapp, :port, default: 4000 end The we can retrieve the values depending on the value of the OS environment variable $MYAPP_ENVIRONMENT: ... with {:ok, env} &lt;- MyApp.Config.env(), {:ok, port} &lt;- Myapp.Config.port(env) do ... do something with the port ... end ...","ref":"readme.html#handling-different-environments","title":"Skogsrå - Handling different environments","type":"extras"},{"doc":"By default, Skogsrå caches the values of the variables using :persistent_term Erlang module. This makes reads very fast, but writes are very slow. So avoid setting or reloading values to avoid performance issues (see Setting and reloading variables). If you don&#39;t want to cache the values, you can set it to false: defmodule MyApp.Config do use Skogsra app_env :value, :myapp, :value, cached: false end","ref":"readme.html#caching-variables","title":"Skogsrå - Caching variables","type":"extras"},{"doc":"Every variable definition will generate two additional functions for setting and reloading the values e.g: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, default: 4000 end will have the functions: MyApp.Config.put_my_port/1 for setting the value of the variable at runtime. MyApp.Config.reload_my_port/ for reloading the value of the variable at runtime.","ref":"readme.html#setting-and-reloading-variables","title":"Skogsrå - Setting and reloading variables","type":"extras"},{"doc":"It&#39;s possible to document a configuration variables using the module attribute @envdoc e.g: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, default: 4000 end Skogsra then will automatically generate instructions on how to use the variable. This extra documentation can be disable with the following: config :skogsra, generate_docs: false Note: for &quot;private&quot; configuration variables you can use @envdoc false.","ref":"readme.html#automatic-docs-generation","title":"Skogsrå - Automatic docs generation","type":"extras"},{"doc":"Skogsra will try to generate the appropriate spec for every function generated. In our example, given the default value is an integer, the function spec will be the following: @spec my_port() :: {:ok, integer()} | {:error, binary()} @spec my_port(Skogsra.Env.namespace()) :: {:ok, integer()} | {:error, binary()} Note: The same applies for my_port!/0, reload_my_port/0 and put_my_port/1.","ref":"readme.html#automatic-spec-generation","title":"Skogsrå - Automatic spec generation","type":"extras"},{"doc":"Every Skogsra module includes the functions template/1 and template/2 for generating OS environment variable files e.g. continuing our example: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, default: 4000 end For Elixir releases: iex(1)&gt; Myapp.Config.template(&quot;env&quot;) :ok will generate the file env with the following contents: # DOCS My port # TYPE integer MYAPP_PORT=&quot;Elixir.Application&quot; For Unix: iex(1)&gt; Myapp.Config.template(&quot;env&quot;, type: :unix) :ok will generate the file env with the following contents: # DOCS My port # TYPE integer export MYAPP_PORT=&#39;Elixir.Application&#39; For Windows: iex(1)&gt; Myapp.Config.template(&quot;env.bat&quot;, type: :windows) :ok will generate the file env.bat with the following contents: :: DOCS My port :: TYPE integer SET MYAPP_PORT=&quot;Elixir.Application&quot;","ref":"readme.html#automatic-template-generation","title":"Skogsrå - Automatic template generation","type":"extras"},{"doc":"By default, Skogsrå loads variables in the following order: OS environment variables or :system. Application configuratuon or :config. This means that every variable has the following defaults: For binding_order is [:system, :config]. For binding_skip is []. These two values can be modified globally via configuration e.g: For globally changing the variable binding order: config :skogsra, binding_order: [:config, :system] For globally skipping :system: config :skogsra, binding_skip: [:system] Or be modified per app_env e.g: For changing MyApp.Config.my_port/0 binding order: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, binding_order: [:config, :system] end For skipping :system in MyApp.Config.my_port/0: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, binding_skip: [:system] end Additionally, we can create new variable bindings by implementing Skogsra.Binding behaviour e.g. an implementation for loading JSON configuration files would be: defmodule MyApp.Json do use Skogsra.Binding alias Skogsra.Env @impl true def init(%Env{} = env) do options = Env.extra_options(env) case options[:config_path] do nil -&gt; {:error, &quot;JSON config path not specified&quot;} path -&gt; load(path) end end @impl true def get_env(%Env{} = env, config) when is_map(config) do name = Env.os_env(env) value = config[name] {:ok, value} end # Helpers # Loads JSON once and caches it in a :persistent_term using the path # as the key. @spec load(binary()) :: {:ok, map()} | {:error, term()} defp load(path) do with nil &lt;- :persistent_term.get(path, nil), {:ok, contents} &lt;- File.read(path), {:ok, config} &lt;- Jason.decode(contents), :ok &lt;- :persistent_term.put(path, config) do {:ok, config} else {:error, reason} -&gt; {:error, &quot;Cannot load \#{path} due to \#{inspect(reason)}&quot;} config -&gt; {:ok, config} end end end The previous implementation expects variables to be named the same as the OS environment variables e.g: { &quot;MYAPP_PORT&quot;: 5000 } Then our variable declaration would look something like the following: defmodule MyApp.Config do use Skogsra @envdoc &quot;My port&quot; app_env :my_port, :myapp, :port, binding_order: [:system, :config, MyApp.Json], config_path: &quot;\#{Path.cwd!()}/priv/config.json&quot;, default: 4000 end If no :system or :config is found, it will try to load the variable from the JSON file e.g: iex&gt; MyApp.Config.port() {:ok, 5000} Note: The same casting rules apply for all bindings.","ref":"readme.html#custom-variable-bindings","title":"Skogsrå - Custom variable bindings","type":"extras"},{"doc":"Skogsrå includes two simple configuration providers compatible with mix release for Elixir ≥ 1.9: YAML configuration provider: - app: &quot;my_app&quot; # Name of the application. module: &quot;MyApp.Repo&quot; # Optional module/namespace. config: # Actual configuration. database: &quot;my_app_db&quot; username: &quot;postgres&quot; password: &quot;postgres&quot; hostname: &quot;localhost&quot; port: 5432 JSON configuration provider: [ { &quot;app&quot;: &quot;my_app&quot;, &quot;module&quot;: &quot;MyApp.Repo&quot;, &quot;config&quot;: { &quot;database&quot;: &quot;my_app_db&quot;, &quot;username&quot;: &quot;postgres&quot;, &quot;password&quot;: &quot;postgres&quot;, &quot;hostname&quot;: &quot;localhost&quot;, &quot;port&quot;: 5432 } } ] Both configurations would be equivalent to: config :my_app, MyApp.Repo, database: &quot;my_App_db&quot;, username: &quot;postgres&quot; password: &quot;postgres&quot; hostname: &quot;localhost&quot; port: 5432 For using these config providers, just add the following to your release configuration: For YAML configurations: config_providers: [{Skogsra.Provider.Yaml, [&quot;/path/to/config/file.yml&quot;]}] For JSON configurations: config_providers: [{Skogsra.Provider.Json, [&quot;/path/to/config/file.json&quot;]}] Note: If the module you&#39;re using in you&#39;re config does not exist, then change it to namespace e.g: namespace: &quot;MyApp.Repo&quot;. Otherwise, it will fail loading it.","ref":"readme.html#elixir-release-yaml-and-json-config-providers","title":"Skogsrå - Elixir release YAML and JSON config providers","type":"extras"},{"doc":"Hab is an Oh My ZSH plugin for loading OS environment variables automatically. By default, Hab will try to load .envrc file, but it&#39;s possible to have several of those files for different purposes e.g: .envrc.prod for production OS variables. .envrc.test for testing OS variables. .envrc for development variables. Hab will load the development variables by default, but it can load the other files using the command hab_load &lt;extension&gt; e.g. loading .envrc.prod would be as follows: ~/my_project $ hab_load prod [SUCCESS] Loaded hab [/home/user/my_project/.envrc.prod]","ref":"readme.html#using-with-hab","title":"Skogsrå - Using with Hab","type":"extras"},{"doc":"The package can be installed by adding skogsra to your list of dependencies in mix.exs. For Elixir ≥ 1.8 and Erlang ≥ 22 def deps do [{:skogsra, &quot;~&gt; 2.2&quot;}] end For Elixir ≥ 1.9, Erlang ≥ 22 and YAML config provider support: def deps do [ {:skogsra, &quot;~&gt; 2.2&quot;}, {:yamerl, &quot;~&gt; 0.7&quot;} ] end For Elixir ≥ 1.9, Erlang ≥ 22 and JSON config provider support: def deps do [ {:skogsra, &quot;~&gt; 2.2&quot;}, {:jason, &quot;~&gt; 1.1&quot;} ] end","ref":"readme.html#installation","title":"Skogsrå - Installation","type":"extras"},{"doc":"Alexander de Sousa.","ref":"readme.html#author","title":"Skogsrå - Author","type":"extras"},{"doc":"Skogsrå is released under the MIT License. See the LICENSE file for further details.","ref":"readme.html#license","title":"Skogsrå - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Enhancements Added JSON config provider. Added new Skogsra.Binding behaviour for adding custom variable bindings. New option binding_order for setting a custom order for variable binding (defaults to [:system, :config]). Possible values: :system: For loading OS environment variables. :config: For loading application configuration variables. module(): For loading variables using a custom module implementing Skogsra.Binding behaviour. Added binding_skip option to skip one or several variable binding types (defaults to []). Breaking changes Improved YAML config provider by making it equivalent to the JSON provider. Deprecations The option skip_config was deprecated favoring binding_skip: [:config]. The option skip_system was deprecated favoring binding_skip: [:system].","ref":"changelog.html#changelog-for-2-2-0","title":"Changelog - Changelog for 2.2.0","type":"extras"},{"doc":"Bug fixes Fixed bug where Skogsra.Type couldn&#39;t be used as a type (see Custom Type Fails at get_spec_type)","ref":"changelog.html#changelog-for-2-1-1","title":"Changelog - Changelog for 2.1.1","type":"extras"},{"doc":"Enhancements Improved function specs. Improved generated docs. Added option to avoid automatically generated docs. Added function for OS environment variable generation for Unix, Releases and Windows.","ref":"changelog.html#changelog-for-2-1-0","title":"Changelog - Changelog for 2.1.0","type":"extras"},{"doc":"Enhancements Improved documentation.","ref":"changelog.html#changelog-for-2-0-4","title":"Changelog - Changelog for 2.0.4","type":"extras"},{"doc":"Enhancements Improved errors when a variable is missing.","ref":"changelog.html#changelog-for-2-0-3","title":"Changelog - Changelog for 2.0.3","type":"extras"},{"doc":"Enhancements Added :module built-in type. Added :unsafe_module built-in type.","ref":"changelog.html#changelog-for-2-0-2","title":"Changelog - Changelog for 2.0.2","type":"extras"},{"doc":"Enhancements Added Skogsra.Type behaviour for defining custom types. Application configuration values are now casted as well to the defined type in the Skogsra environment variable definition. Added YAML configuration provider.","ref":"changelog.html#changelog-for-2-0-0","title":"Changelog - Changelog for 2.0.0","type":"extras"},{"doc":"Enhancements Namespaces now inherit values from default namespace. Favoring the use of :persistent_terms over :ets tables. This avoids the creation of an application tree for this project, thus making it even faster.","ref":"changelog.html#changelog-for-1-3-0","title":"Changelog - Changelog for 1.3.0","type":"extras"},{"doc":"Bug fixes Fixed bug where Skogsra.Cache didn&#39;t work at compilation time.","ref":"changelog.html#changelog-for-1-2-1","title":"Changelog - Changelog for 1.2.1","type":"extras"},{"doc":"Enhancements Added autogenerated reload functions. Added autogenerated setter functions. Improved documentation. Code rearrangement and refactor for maintainability.","ref":"changelog.html#changelog-for-1-2-0","title":"Changelog - Changelog for 1.2.0","type":"extras"}]