sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"small-example","id":"Small example"},{"anchor":"available-options","id":"Available options"},{"anchor":"automatic-type-casting","id":"Automatic type casting"},{"anchor":"explicit-type-casting","id":"Explicit type casting"},{"anchor":"explicit-os-environment-variable-names","id":"Explicit OS environment variable names"},{"anchor":"required-variables","id":"Required variables"},{"anchor":"handling-different-environments","id":"Handling different environments"},{"anchor":"caching-variables","id":"Caching variables"},{"anchor":"setting-and-reloading-variables","id":"Setting and reloading variables"},{"anchor":"automatic-docs-generation","id":"Automatic docs generation"},{"anchor":"automatic-spec-generation","id":"Automatic spec generation"},{"anchor":"automatic-template-generation","id":"Automatic template generation"},{"anchor":"custom-variable-bindings","id":"Custom variable bindings"},{"anchor":"elixir-release-yaml-and-json-config-providers","id":"Elixir release YAML and JSON config providers"},{"anchor":"using-with-hab","id":"Using with Hab"},{"anchor":"installation","id":"Installation"},{"anchor":"author","id":"Author"},{"anchor":"license","id":"License"}],"id":"readme","title":"Skogsrå"},{"group":"","headers":[{"anchor":"changelog-for-2-2-0","id":"Changelog for 2.2.0"},{"anchor":"changelog-for-2-1-1","id":"Changelog for 2.1.1"},{"anchor":"changelog-for-2-1-0","id":"Changelog for 2.1.0"},{"anchor":"changelog-for-2-0-4","id":"Changelog for 2.0.4"},{"anchor":"changelog-for-2-0-3","id":"Changelog for 2.0.3"},{"anchor":"changelog-for-2-0-2","id":"Changelog for 2.0.2"},{"anchor":"changelog-for-2-0-0","id":"Changelog for 2.0.0"},{"anchor":"changelog-for-1-3-0","id":"Changelog for 1.3.0"},{"anchor":"changelog-for-1-2-1","id":"Changelog for 1.2.1"},{"anchor":"changelog-for-1-2-0","id":"Changelog for 1.2.0"}],"id":"changelog","title":"Changelog"}],"modules":[{"group":"Skogsra","id":"Skogsra","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"__using__/1","id":"__using__/1"},{"anchor":"app_env/4","id":"app_env/4"}]}],"title":"Skogsra"},{"group":"Library Core","id":"Skogsra.Core","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"get_env/1","id":"get_env/1"},{"anchor":"get_env!/1","id":"get_env!/1"},{"anchor":"put_env/2","id":"put_env/2"},{"anchor":"reload_env/1","id":"reload_env/1"}]}],"title":"Skogsra.Core"},{"group":"Library Core","id":"Skogsra.Env","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:app_name/0","id":"app_name/0"},{"anchor":"t:binding/0","id":"binding/0"},{"anchor":"t:bindings/0","id":"bindings/0"},{"anchor":"t:key/0","id":"key/0"},{"anchor":"t:keys/0","id":"keys/0"},{"anchor":"t:namespace/0","id":"namespace/0"},{"anchor":"t:option/0","id":"option/0"},{"anchor":"t:options/0","id":"options/0"},{"anchor":"t:t/0","id":"t/0"},{"anchor":"t:type/0","id":"type/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"__struct__/0","id":"__struct__/0"},{"anchor":"binding_order/1","id":"binding_order/1"},{"anchor":"cached?/1","id":"cached?/1"},{"anchor":"default/1","id":"default/1"},{"anchor":"extra_options/1","id":"extra_options/1"},{"anchor":"new/4","id":"new/4"},{"anchor":"os_env/1","id":"os_env/1"},{"anchor":"required?/1","id":"required?/1"},{"anchor":"type/1","id":"type/1"}]}],"title":"Skogsra.Env"},{"group":"Generalizations","id":"Skogsra.Cache","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"get_env/1","id":"get_env/1"},{"anchor":"put_env/2","id":"put_env/2"}]}],"title":"Skogsra.Cache"},{"group":"Generalizations","id":"Skogsra.Type","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"__using__/1","id":"__using__/1"},{"anchor":"cast/2","id":"cast/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:cast/1","id":"cast/1"}]}],"title":"Skogsra.Type"},{"group":"Variable Bindings","id":"Skogsra.App","title":"Skogsra.App"},{"group":"Variable Bindings","id":"Skogsra.Binding","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"__using__/1","id":"__using__/1"},{"anchor":"get_env/2","id":"get_env/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"anchor":"c:get_env/2","id":"get_env/2"},{"anchor":"c:init/1","id":"init/1"}]}],"title":"Skogsra.Binding"},{"group":"Variable Bindings","id":"Skogsra.Sys","title":"Skogsra.Sys"},{"group":"Documentation Generation","id":"Skogsra.Docs","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:docs/0","id":"docs/0"},{"anchor":"t:function_name/0","id":"function_name/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"gen_full_docs/6","id":"gen_full_docs/6"},{"anchor":"gen_put_docs/3","id":"gen_put_docs/3"},{"anchor":"gen_reload_docs/3","id":"gen_reload_docs/3"},{"anchor":"gen_short_docs/3","id":"gen_short_docs/3"}]}],"title":"Skogsra.Docs"},{"group":"Documentation Generation","id":"Skogsra.Spec","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"gen_bang_spec/2","id":"gen_bang_spec/2"},{"anchor":"gen_full_spec/2","id":"gen_full_spec/2"},{"anchor":"gen_put_spec/2","id":"gen_put_spec/2"},{"anchor":"gen_reload_spec/2","id":"gen_reload_spec/2"}]}],"title":"Skogsra.Spec"},{"group":"OS Environment Template","id":"Skogsra.Template","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:t/0","id":"t/0"},{"anchor":"t:type/0","id":"type/0"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"__struct__/0","id":"__struct__/0"},{"anchor":"generate/2","id":"generate/2"},{"anchor":"new/1","id":"new/1"}]}],"title":"Skogsra.Template"},{"group":"Config Providers","id":"Skogsra.Provider.Json","title":"Skogsra.Provider.Json"},{"group":"Config Providers","id":"Skogsra.Provider.Yaml","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:key/0","id":"key/0"}]}],"title":"Skogsra.Provider.Yaml"}],"tasks":[]}